# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Add . to reltag for namedversion to work
%define reltag .Final

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib
%bcond_without tests

%define namedversion %{version}%{reltag}

%define repodir %{_javadir}/repository.jboss.com/jgroups/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

Name:           jgroups
Version:        2.6.22
Release:        1%{?dist}
Epoch:          1
Summary:        Toolkit for reliable multicast communication
License:        LGPLv2+
URL:            http://www.jgroups.org/
Group:          Development/LIbraries/Java
# git clone git://github.com/belaban/JGroups.git && mv JGroups JGroups-2.6.22.Final && cd JGroups-2.6.22.Final && git checkout JGroups_2_6_22_Final && cd ..
# HEAD is now at a9f97e1... Merge branch 'Branch_JGroups_2_6' of github.com:belaban/JGroups into Branch_JGroups_2_6
# tar cjf JGroups-2.6.22.Final.tar.bz2 JGroups-2.6.22.Final
Source0:        JGroups-%{namedversion}.tar.bz2
Source1:        jgroups-component-info.xml
Source2:	jgroups-upload.sh
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
# To use JGroups one needs:
# commons-logging.jar
Requires:       jakarta-commons-logging
# log4j.jar
Requires:       log4j
# To run JGroups you need to have an XML parser installed on your system.
# If you use JDK 1.4 or higher, you can use the parser that is shipped with it.
Requires:       jaxp_parser_impl
# If you want to use the JGroups JMS protocol ( org.jgroups.protocols.JMS ),
# then you will also need to place jms.jar somewhere in your CLASSPATH. 
Requires:       jms
# Place the JAR files somewhere in your CLASSPATH , and you're ready to start
# using JGroups.
# FIXME Do we need bsh at run-time?
Requires:       bsh
#Optional:      mx4j
BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit
BuildRequires:  bsh
BuildRequires:  jakarta-commons-logging
BuildRequires:  jaxp_parser_impl
BuildRequires:  jms
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  maven-deploy-plugin
BuildRequires:  mx4j
BuildRequires:  xalan-j2
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JGroups is a toolkit for reliable multicast communication. (Note that
this doesn't necessarily mean IP Multicast, JGroups can also use
transports such as TCP). It can be used to create groups of processes
whose members can send messages to each other. The main features include

    * Group creation and deletion. Group members can be spread across
      LANs or WANs
    * Joining and leaving of groups
    * Membership detection and notification about joined/left/crashed members
    * Detection and removal of crashed members
    * Sending and receiving of member-to-group messages (point-to-multipoint)
    * Sending and receiving of member-to-member messages (point-to-point)

To use JGroups one needs:
 commons-logging.jar
 log4j.jar

To run JGroups you need to have an XML parser installed on your system.
If you use JDK 1.4 or higher, you can use the parser that is shipped with it.

If you want to use the JGroups JMS protocol ( org.jgroups.protocols.JMS ),
then you will also need to place jms.jar somewhere in your CLASSPATH. 

Place the JAR files somewhere in your CLASSPATH , and you're ready to start
using JGroups.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n JGroups-%{namedversion}

find . -type f -name .cvsignore | xargs -t rm
find . -type f -name "*.jar" | xargs -t rm

# this test requires bouncycastle
rm tests/junit/org/jgroups/protocols/ENCRYPTAsymmetricTest.java

pushd lib
ln -s $(build-classpath ant) .
ln -s $(build-classpath ant-launcher) .
ln -s $(build-classpath ant/ant-junit) .
#BUILD/JGroups-2.4.1.src/lib/bcprov-jdk14-117.jar.no
ln -s $(build-classpath bsh) .
ln -s $(build-classpath commons-logging) .
ln -s $(build-classpath jms) .
ln -s $(build-classpath junit) .
ln -s $(build-classpath log4j) .
ln -s $(build-classpath mx4j/mx4j-jmx) .
ln -s $(build-classpath xalan-j2) .
ln -s $(build-classpath xalan-j2-serializer) .
popd

sed -i -e 's:<groupId>org.jgroups</groupId>:<groupId>jgroups</groupId>:' pom.xml

%build
export CLASSPATH=
export OPT_JAR_LIST=`cat %{_sysconfdir}/ant.d/{junit,trax}`
%if %without tests
%{ant} jar javadoc gossiprouter-service jgroups-service
%else
%{ant} jar javadoc gossiprouter-service jgroups-service testreport
%endif

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p dist/jgroups-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
#The following line was commented out because jgroups-core.jar dosen't get generated in this release 2.6.15.GA - gbarreir
#cp -p dist/jgroups-core.jar %{buildroot}%{_javadir}/%{name}-core-%{version}.jar
cp -p dist/jgroups-sources.jar %{buildroot}%{_javadir}/%{name}-sources-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
#%add_to_maven_depmap jgroups jgroups %{namedversion} JPP %{name}
#%add_to_maven_depmap org.jgroups jgroups %{namedversion} JPP %{name}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr dist/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
#ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# services
mkdir -p %{buildroot}%{_datadir}/%{name}-%{version}
for sar in $(pwd)/dist/*.sar; do
    bsar=$(basename ${sar})
    mkdir -p %{buildroot}%{_datadir}/%{name}-%{version}/${bsar}
    pushd %{buildroot}%{_datadir}/%{name}-%{version}/${bsar}
    %{jar} xf ${sar}
    for jar in `find -type f -name "*.jar"`; do
        rm ${jar}
        bjar=$(basename ${jar/-%{namedversion}/})
        ln -s %{_javadir}/${bjar} ${bjar}
    done
    popd
done
#ln -s %{name}-%{version} %{buildroot}%{_datadir}/%{name}
mkdir -p %{buildroot}%{_datadir}/%{name}

# docs
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
cp -pr doc/* %{buildroot}%{_docdir}/%{name}-%{version}

%if %with repolib
mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
cp -p %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{namedversion}-brew/g" %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
cp -p %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar %{buildroot}%{repodirlib}/jgroups.jar
cp -p %{buildroot}%{_javadir}/%{name}-sources-%{namedversion}.jar %{buildroot}%{repodirlib}/jgroups-sources.jar
cp -p pom.xml %{buildroot}%{repodirlib}/jgroups.pom
%{__install} -p -m 755 %{SOURCE2} %{buildroot}%{repodir}/upload.sh
%endif

%clean
rm -rf %{buildroot}

%post

%postun

%files
%defattr(0644,root,root,0755)
%doc CREDITS INSTALL.html LICENSE README
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-sources-%{namedversion}.jar
%{_javadir}*/%{name}-sources.jar
%dir %{_datadir}/%{name}-%{version}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}-%{version}/gossiprouter-service.sar/
%dir %{_datadir}/%{name}-%{version}/jgroups-service.sar
%dir %{_datadir}/%{name}-%{version}/jgroups-service.sar/META-INF
%{_datadir}/%{name}-%{version}/jgroups-service.sar/META-INF/MANIFEST.MF
%{_datadir}/%{name}-%{version}/jgroups-service.sar/META-INF/jboss-service.xml
%{_datadir}/%{name}-%{version}/jgroups-service.sar/commons-logging.jar
%{_datadir}/%{name}-%{version}/jgroups-service.sar/jg-magic-map.xml
%{_datadir}/%{name}-%{version}/jgroups-service.sar/jgroups.jar
%{_datadir}/%{name}-%{version}/jgroups-service.sar/log4j.jar
%{_datadir}/%{name}-%{version}/jgroups-service.sar/stacks.xml
%{_datadir}/maven2/poms/JPP-%{name}.pom
#%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
#%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Oct 15 2012 Martha Benitez <mbenitez@redhat.com> - 1:2.6.22-1
- Upgrade to 2.6.22.Final
